config/routes.rb
Salasrosario::Application.routes.draw do
  
  root :to => 'reservations#index' #RAILS 3

  resources :users,                only: [:index, :new, :create, :show, :edit, :update, :destroy]
  resources :musicians,            only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,                only: [:index, :new, :create, :edit, :update]
  resources :rooms,                only: [:index, :edit, :update]
  resources :room_prices,          only: [:index, :new, :create, :show, :edit, :update, :destroy]
  resources :reservation_types,    only: [:index]
  resources :reservations,         only: [:index, :new, :create, :show, :edit, :update]
  resources :cancellations,        only: [:new, :create]

end

app/models/cancellation.rb
class Cancellation < ActiveRecord::Base
  has_one :reservation
  has_one :user
  attr_accessible :reservation_id, :user_id
  validates :reservation, :user, :presence => true
end

app/controllers/cancellations_controller.rb
class CancellationsController < ApplicationController
  # GET /cancellations
  # GET /cancellations.json
  def index
    @cancellations = Cancellation.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @cancellations }
    end
  end

  # GET /cancellations/1
  # GET /cancellations/1.json
  def show
    @cancellation = Cancellation.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @cancellation }
    end
  end

  # GET /cancellations/new
  # GET /cancellations/new.json
  def new
    @cancellation = Cancellation.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @cancellation }
    end
  end

  # GET /cancellations/1/edit
  def edit
    @cancellation = Cancellation.find(params[:id])
  end

  # POST /cancellations
  # POST /cancellations.json
  def create
    @cancellation = Cancellation.new(params[:cancellation])

    respond_to do |format|
      if @cancellation.save
        format.html { redirect_to @cancellation, notice: 'Cancellation was successfully created.' }
        format.json { render json: @cancellation, status: :created, location: @cancellation }
      else
        format.html { render action: "new" }
        format.json { render json: @cancellation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /cancellations/1
  # PUT /cancellations/1.json
  def update
    @cancellation = Cancellation.find(params[:id])

    respond_to do |format|
      if @cancellation.update_attributes(params[:cancellation])
        format.html { redirect_to @cancellation, notice: 'Cancellation was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @cancellation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cancellations/1
  # DELETE /cancellations/1.json
  def destroy
    @cancellation = Cancellation.find(params[:id])
    @cancellation.destroy

    respond_to do |format|
      format.html { redirect_to cancellations_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/cancellations_helper.rb
module CancellationsHelper
end

app/views/cancellations/_form.html.erb
<%= form_for @cancellation, html: {class: "form-horizontal"} do |f| %>
  
  <% if @cancellation.errors.any? %>
    <div class="alert alert-error">
      <button type="button" class="close" data-dismiss="alert">×</button>
      <h3><%= pluralize(@cancellation.errors.count, "error") %> prohibited this cancellation from being saved:</h3>
      <ul>
      <% @cancellation.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="control-group">
    <%= f.label :reservation_id, { class: 'control-label' } %>
    <div class="controls">
      <%= f.number_field :reservation_id %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :user_id, { class: 'control-label' } %>
    <div class="controls">
      <%= f.number_field :user_id %>
    </div>
  </div>

  <div class="form-actions">
    <%= f.submit "Guardar", { class: 'btn btn-primary' } %>
  </div>

<% end %>

app/views/cancellations/edit.html.erb
<h1>Editar Cancelacion</h1>

<%= render 'form' %>

<%= link_to 'Detalle', @cancellation %> |
<%= link_to 'Atras', cancellations_path %>

app/views/cancellations/index.html.erb
<h1>Listado de Cancelaciones</h1>

<table>
  <tr>
    <th>Reservation</th>
    <th>User</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @cancellations.each do |cancellation| %>
  <tr>
    <td><%= cancellation.reservation_id %></td>
    <td><%= cancellation.user_id %></td>
    <td><%= link_to 'Detalle', cancellation %></td>
    <td><%= link_to 'Editar', edit_cancellation_path(cancellation) %></td>
    <td><%= link_to 'Eliminar', cancellation, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'Nueva Cancelacion', new_cancellation_path %>

app/views/cancellations/new.html.erb
<h1>Nueva Cancelacion</h1>

<%= render 'form' %>

<%= link_to 'Atras', cancellations_path %>

app/views/cancellations/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Reservation:</b>
  <%= @cancellation.reservation_id %>
</p>

<p>
  <b>User:</b>
  <%= @cancellation.user_id %>
</p>


<%= link_to 'Editar', edit_cancellation_path(@cancellation) %> |
<%= link_to 'Atras', cancellations_path %>